#include <iostream>
#include "CopaDoMundo.h"
#include "Equipe.h"

using namespace std;

// ----------------------------------------------------------------------------
//Q3
CopaDoMundo::CopaDoMundo(int tam)
{
    // Implemente aqui sua solucao!

    n = tam;
    equipes = new Equipe[n];
}

CopaDoMundo::~CopaDoMundo()
{
    // Implemente aqui sua solucao!

    delete [] equipes;
}

void CopaDoMundo::imprime()
{
    // Implemente aqui sua solucao!
    // Se necessario remova o codigo abaixo.

    float media = 0.0;

    for(int i=0; i < n; i++)
    {
        cout << "Grupo: " << equipes[i].getGrupo() << endl;
        cout << "Pontos: " << equipes[i].getPontos() << endl << endl;

        media += equipes[i].getPontos();
    }

    media = media / n;

    cout << " --------------------------------------- " << endl;
    cout << "Media: " << media << endl;
    cout << " --------------------------------------- " << endl << endl;
    cout << "Aprovados: " << endl << endl;

    for(int i=0; i < n; i++)
    {
        if( equipes[i].getPontos() > media )
        {
            cout << "Grupo: " << equipes[i].getGrupo() << endl;
            cout << "Pontos: " << equipes[i].getPontos() << endl << endl;
        }
    }
}

void CopaDoMundo::primeiraGrupo(int *g, int *p)
{
    int menorGrupo = equipes[0].getGrupo();
    int maiorPontuacao = 0;

    for(int i=1; i < n; i++)
    {
        if( menorGrupo > equipes[i].getGrupo() )
            menorGrupo = equipes[i].getGrupo();
    }

    for(int i=0; i < n; i++)
    {
        if( equipes[i].getGrupo() == menorGrupo )
        {
            if( maiorPontuacao < equipes[i].getPontos() )
                maiorPontuacao = equipes[i].getPontos();
        }
    }

    *g = menorGrupo;
    *p = maiorPontuacao;
}
//-Q3
// ----------------------------------------------------------------------------
