#include "MatrizX.h"
#include <iostream>
#include <cstdlib>

using namespace std;

// ----------------------------------------------------------------------------
//Q4
MatrizX::MatrizX(int n)
{
    tam = n;
    vet = new float[2 * tam]; // Duas diagonais, cada uma com tamanho igual a tam
}


MatrizX::~MatrizX()
{
    delete [] vet;
}


int MatrizX::detInd(int i, int j)
{
    if(i < 0 || i >= tam || j < 0 || j >= tam) // Um dos índices é inválido
    {
        return -1;
    }
    else if(i != j  &&  i+j != tam-1) // Posição está fora da diagonal principal E fora da diagonal secundária
    {
        return -2;
    }
    else // Posição pode ser atribuída normalmente
    {
        if(i == j) // Está na diagonal principal
        {
            return i;
        }
        else // Está na diagonal secundária
        {
            return tam + i;
        }
    }
}


void MatrizX::set(int i, int j, float val)
{
    int k = detInd(i, j);

    if(k == -1 || k == -2)
    {
        cout << "Nao e possivel atribuir na posicao informada" << endl;
    }
    else
    {
        vet[k] = val;
    }
}
//-Q4
// ----------------------------------------------------------------------------



float MatrizX::get(int i, int j)
{
    int k = detInd(i, j);

    if(k == -1)
    {
        cout << "Posicao Invalida" << endl;
        exit(0);
    }
    else if(k == -2)
    {
        return 0;
    }
    else
    {
        return vet[k];
    }
}
