#include <iostream>
#include "Equipe.h"
#include "CopaDoMundo.h"
#include "MatrizX.h"

using namespace std;

// ############################################################################
// TVC 1 -- ESTRUTURA DE DADOS e LABORATORIO DE PROGRAMACAO II
// DATA: 23/04/2018
// PREENCHER ESTE CABECALHO COM SUAS INFORMACOES
// ALUNO(A):
// MATRICULA:
// ############################################################################

// ----------------------------------------------------------------------------
//Q1
int* interVet(int a[], int b[], int c[], int n, int *maior)
{
    /* ATENÇÃO - Q1 e Q4 se referem às questões do documento Questões1e4ReposiçãoTVC1.pdf */

    int* vetorIntercalado = new int[n*3];
    int contador = 0; // contador percorre vetorIntercalado
    *maior = a[0]; // Inicializa maior com um valor qualquer válido

    // i percorre a, b e c
    for(int i=0; i < n; i++)
    {
        vetorIntercalado[contador] = a[i];
        contador++;

        if(a[i] > *maior)
            *maior = a[i];


        vetorIntercalado[contador] = b[i];
        contador++;

        if(b[i] > *maior)
            *maior = b[i];


        vetorIntercalado[contador] = c[i];
        contador++;

        if(c[i] > *maior)
            *maior = c[i];
    }

    return vetorIntercalado;
}
// ----------------------------------------------------------------------------
//-Q1

// ----------------------------------------------------------------------------
//Q2
int somaDigitos(int val, int *nr)
{
    // Implemente aqui sua solucao!

    if(val == 0)
    {
        *nr = 0;
        return 0;
    }
    else
    {
        int digito = val % 10;
        int restoDoNumero = val / 10;

        int resultado = digito + somaDigitos(restoDoNumero, nr);
        (*nr)++;

        return resultado;
    }
}
//-Q2
// ----------------------------------------------------------------------------

int main()
{
    srand(1);
    cout << "TVC 1 -- ESTRUTURA DE DADOS e LAB. DE PROG. II" << endl;
    cout << "FAVOR PREENCHER OS SEUS DADOS" << endl;

    // TESTE DA QUESTAO 1 -----------------------------------------------------
    cout << endl << "TESTE DA QUESTAO 1" << endl;
    int a[5] = {1, 4, 7, 10, 13};
    int b[5] = {2, 5, 8, 11, 14};
    int c[5] = {3, 6, 9, 12, 15};
    int maior = 0;
    int* intercalado = interVet(a, b, c, 5, &maior);
    if(intercalado != NULL)
    {
        for(int i=0; i < 15; i++)
            cout << intercalado[i] << " ";
        cout << endl << "Maior valor: " << maior << endl;
        delete [] intercalado;
    }

    // ------------------------------------------------------------------------

    // TESTE DA QUESTAO 2 -----------------------------------------------------
    cout << endl << "TESTE DA QUESTAO 2" << endl;
    int soma=0, nrec=0;
    soma = somaDigitos(96541,&nrec);
    cout << "Soma dos digitos de 96541: " << soma << endl;
    cout << "Numero de chamadas recursivas: " << nrec << endl;
    cout << endl;
    // ------------------------------------------------------------------------

    // TESTE DA QUESTAO 3 -----------------------------------------------------
    cout << endl << "TESTE DA QUESTAO 3" << endl;
    CopaDoMundo cm2018(16);
    int grupo=0, pontos=0;
//    cout << "Equipes: " << endl;
//    cm2018.imprimeEquipes();
    cout << "Equipes: " << endl;
    cm2018.imprime();
    cm2018.primeiraGrupo(&grupo, &pontos);
    cout << "Pontos da equipe primeira colocada do grupo " << grupo << ": " << pontos << endl;
    cout << endl;
    // ------------------------------------------------------------------------

    // TESTE DA QUESTAO 4 -----------------------------------------------------
    cout << endl << "TESTE DA QUESTAO 4" << endl;
    MatrizX matriz(6);
    for(int i=0; i < 6; i++)
        for(int j=0; j < 6; j++)
            matriz.set(i, j, i*6 + j + 10);
    for(int i=0; i < 6; i++)
    {
        for(int j=0; j < 6; j++)
            cout << matriz.get(i, j) << " ";
        cout << endl;
    }

    return 0;
}
